/*
 * $Id: ClientScrobblePlayer.java,v 1.8 1998/04/07 12:30:25 vmallet Exp $
 *
 *
 * $Log: ClientScrobblePlayer.java,v $
 * Revision 1.8  1998/04/07 12:30:25  vmallet
 * Mainly debug output.
 *
 * Revision 1.7  1998/04/06 21:55:38  vmallet
 * Last attempt to make this getComponent() work properly.
 *
 * Revision 1.6  1998/04/06 18:50:51  vmallet
 * Fixed a bug in the getComponent() method (when playletters is null).
 *
 * Revision 1.5  1998/04/06 09:51:15  vmallet
 * Slightly modified the debug output.
 *
 * Revision 1.4  1998/04/05 19:53:52  lozac
 * Added the GUI getComponent() code.
 *
 * Revision 1.3  1998/04/03 19:37:36  vmallet
 * Fixed the constructors.
 * Removed the Displayable code.
 *
 * Revision 1.2  1998/04/03 18:16:48  lozac
 * nothing.
 * /
 *
 * Revision 1.1  1998/04/03 18:13:19  lozac
 * Initial revision
 *
 *
 */ 

package scrobble;

import game.*;
import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import com.sun.java.swing.*;
import com.sun.java.swing.border.*;

/**
 * The <code>ClientScrobblePlayer</code> class adds the client functionnalities to <code>ScrobblePlayer</code>, 
 * such as displaying.
 * @author  Kristell Lozac'hmeur(lozac@email.enst.fr)
 * @version $Revision: 1.8 $
 */
public class ClientScrobblePlayer extends ScrobblePlayer {

  /**
   * The panel which represents the letters of Player.
   */   
  JPanel lettersPanel;  

  /**
   * The panel which represents the Player (his name and his score) and his letters.
   */   
  JPanel BigPanel;  



   // constructor

  /**
   * Creates a new ClientScrobblePlayer
   */
  public ClientScrobblePlayer() { 
   super();
  }


  /**
   * Creates a new ClientScrobblePlayer
   */
  public ClientScrobblePlayer(int id, Object frameData) {
    super(id, frameData);
  }  

  
  //  /**
  //   * creates a new ClientScrobblePlayer with his name.
  //   * @param name the ClientScrobblePlayer's name.
  //   */
  //  public ClientScrobblePlayer(String name) {
  //    super(name);
  //  }

  //@@ A ENLEVER !!!!!!!!!!!!!!

 /**
   * creates a new ClientScrobblePlayer with his name.
   * @param name the ClientScrobblePlayer's name.
   */
  public ClientScrobblePlayer(String name, int score, Letter letter1, Letter letter2, Letter letter3 ) {
      o = new Observable() {
      public void notifyObservers(Object o) {
	setChanged();
	super.notifyObservers(o);
      }
    };
    this.name = name;
    this.score = score;
    playletters = new Vector();
    playletters.addElement(letter1);
    playletters.addElement(letter2);
    playletters.addElement(letter3);

  }

  /**
   * Creates a new ClientScrobblePlayer with his name and his identity.
   *
   * @param name the ClientScrobblePlayer's name.
   * @param id the identity of Player.
   */
  public ClientScrobblePlayer(String name, int id) {
    super(name, id);
  }

  // Methods

  /**
   * Returns a Panel containing the name, the score and the letters of the Player
   */  
  public Component getComponent() {
    //@@ ENLEVER LES TRACES
    super.getComponent();  // Forces the creation of playerPanel.
    
    if (BigPanel == null) {
      BigPanel = new JPanel();
      BigPanel.setBorder(new EtchedBorder());
      BigPanel.setLayout(new BoxLayout(BigPanel, BoxLayout.Y_AXIS));
      BigPanel.add(playerPanel);
      
      updateLettersPanel();

      BigPanel.add(lettersPanel);
    }



    return BigPanel;
  }



  /**
   * [DESCRIBE ME]
   */  
  void updateLettersPanel() {
    boolean created = lettersPanel != null;
    if (!created) {
      System.out.println("<ClientScrobblePlayer> suis dans l'if letterspanel == 0");
      lettersPanel = new JPanel();
      lettersPanel.setLayout(new BoxLayout(lettersPanel, BoxLayout.X_AXIS));
      lettersPanel.setBorder(new BevelBorder(BevelBorder.LOWERED));
    }

//     lettersPanel.invalidate();
    lettersPanel.removeAll();
    if (playletters != null) {
      System.out.println("<ClientScrobblePlayer> suis dans l'if playletters !=0");
      for (int i = 0; i < getNbLetters(); i++) {
	//	System.out.println("<ClientScrobblePlayer> suis dans la boucle pour ajouter les lettres . i = " + i);
	lettersPanel.add(getLetterAt(i).getComponent());
      }
    }
    else {
      System.out.println("<ClientScrobblePlayer> suis dans le else playletter=0 ");
      for (int i = 0; i < getNbLetters(); i++) {
	lettersPanel.add(new Letter().getComponent());
      }
    }
    
//     if (!created)
    lettersPanel.revalidate();
//     else
    //      lettersPanel.doLayout();
    //    lettersPanel.validate();
    System.out.println( "lp=" + lettersPanel);
  }
  

  /**
   * Invoked when a new data frame is received.
   * @param frame the frame that has just been received.
   */  
  public void frameReceived(Object link, LinkFrame frame) {
    int request = frame.getRequest();

    if (frame.getSubRequest() == getId()) {
      switch (request) {
      case RQ_PLAYERCHANGELETTER :
	playletters = (Vector) frame.getData();
	System.out.println("<ScrobblePlayer> RQ_PLAYERCHANGELETTER: " + this);
	updateLettersPanel(); 
	break;
      case RQ_PLAYERCHANGENBLETTERS :
	if (playletters == null) { // else dont care.
	  nbletters = ((Integer) frame.getData()).intValue();
	  updateLettersPanel();
	}
	break;
      default : 
	super.frameReceived(link, frame);
	break;
      }
    }
  }
}
