/*
 * $Id: Configuration.java,v 1.3 1998/04/07 07:52:57 dunand Exp $
 *
 *
 * $Log: Configuration.java,v $
 * Revision 1.3  1998/04/07 07:52:57  dunand
 * added getLanguages method
 *
 * Revision 1.2  1998/04/06 09:50:14  vmallet
 * Changed a lot of little things.
 * Added the selected-language code.
 *
 * Revision 1.1  1998/04/04 14:18:41  legras
 * Initial revision
 *
 *
 */

package scrobble;

import game.*;
import scrobble.square.*;//pour la config du board
import java.util.*;
import java.io.*;

/**
 * Configuration.java
 * Has to configure the game
 * 
 * @version $Revision: 1.3 $
 * @author  Helene Legras (legras@enst.fr)
 */
public class Configuration implements Serializable {

  String language;

  BoardShape boardShape;

  boolean privateGame;

  int maxPlayer;

  Vector languages;
  
  
  int selectedLanguageId;
  
  

  //methods

  // Choice of the language
  public void setLanguage(String identifier){
    this.language = identifier;
  }

  public String getLanguage(){
    return language;
  }

  public void setBoardShape(BoardShape shape){
    boardShape = shape;
  }

  public BoardShape getBoardShape(){
    return boardShape;
  }

  public void setPrivate(boolean privateGame){
    this.privateGame = privateGame;
  }

  public boolean isPrivate(){
    return privateGame;
  }

  public void setMaxPlayer(int maximum){
    this.maxPlayer = maximum;
  }

  public int getMaxPlayer(){
    return maxPlayer;
  }

  public void setLanguages(Enumeration list){
    languages = new Vector();
    for (; list.hasMoreElements(); ) 
      languages.addElement(list.nextElement());

    //@@ default language
    if (languages.size() > 0)
      selectedLanguageId = ((Language) languages.elementAt(0)).getIdentifier();
  }

  public Enumeration getLanguages(){
    return(languages.elements());
  }

  /**
   * 
   */
  public int getSelectedLanguageId() {
    return selectedLanguageId;
  }
  
  /**
   * 
   */
  public void setSelectedLanguageId(int id) {
    selectedLanguageId = id;
  }


  public void languageChoice(){
    Language oneLanguage; 
    for (Enumeration e = languages.elements(); e.hasMoreElements(); ) {
      oneLanguage = (Language) e.nextElement();
      System.out.println(oneLanguage.getName());
    }
      //l'utilisateur choisit
   String name = "toto"/*a saisir*/;
   setLanguage(name);
  }

  // Choice of the Boardshape
  public void boardShapeChoice(){
    Vector squareList = new Vector();
    ServerSquare defaultSquare = new ServerSquare();
    BoardShape oneBoardShape = new BoardShape(13,13,defaultSquare,squareList) ;
         //choisir le plateau que vous voulez
    setBoardShape(oneBoardShape);
  }


  // Choice of the nomber of players
  public void maxPlayerChoice(){
     System.out.println("How many (maximum) do you want to be to play?");
     int maxPlayer = 6/*a saisir*/;
     setMaxPlayer(maxPlayer);
  }

  // Choice of private or non private mode
  public void privateChoice(){
    //a faire
  }
}
