
/*
 * $Id: Distribution.java,v 1.2 1998/04/05 17:45:39 granier Exp $
 *
 * 
 * $Log: Distribution.java,v $
 * Revision 1.2  1998/04/05 17:45:39  granier
 * Insertion of debug prints
 *
 * Revision 1.1  1998/04/05 11:40:45  granier
 * Initial revision
 *
 *
 */
package scrobble;


import java.io.*;
import java.util.*;
import java.net.*;


public class Distribution { 
 
  /**
   * if true, enables the printing of debug informations on the console.
   */  
  static boolean debug = true;


  Letter letter, myLetter;
  
  /**
   * Contains the name of the file that will be used as a word source 
   */
  String distriFile ;
  /**
   * Contains all the words of the dictionnary created 
   */
  Vector letters;

  StringTokenizer str;
  /**
   * Contains the average number of words in a dictionnary it is initialised to 100
   */
  int averageLength = 100;
 
  
  // Constuctors


  public Distribution(String file) {
    letters= new Vector(averageLength);  
	
    this.distriFile = file;
    if (debug)
      System.out.println ("<Distribution> Distribution : Loading list of letters in Memory...");
    loadFile();
    if (debug)
      System.out.println ("<Distribution> Distribution : List of letters loaded !");
	
  }

  
  // Methods


  /* pour essayer de lui parler tu verras ca marche  */
  public static void main(String args[]) {
    Distribution distri = new Distribution("test");
    /* if (debug){
     *System.out.println(distri.toString());
     *System.out.println(distri.letters.toString());
     }*/
  }
  
  /**
   * Returns a string representation of the Distribution.
   */
  public String toString ()
    {return( "Distribution of type :" + distriFile  + " Contains : " + letters.size() + " Elements");
    
    }
  
  /**
   * Returns the vector of Letters
   */
  public Vector getLetters(){
    return(letters);
  }
  
  
  /**
   * This method loads the words in the <code>distriFile </code> and adds them to the
   * <code>listOfLetters</code> Vector. This function has no parameters.
   */
  
  void loadFile() {
    URL url = null;
    InputStream sourceFlow = null;
    InputStreamReader reader;
    BufferedReader formatedSource;
    String line;
    char name;
    Integer value;

    try {
     
      url = this.getClass().getResource(distriFile);
      if (debug)
	System.out.println("<distribution> loadFile " + url);
      sourceFlow = url.openStream();
      reader = new InputStreamReader(sourceFlow);
      formatedSource=new BufferedReader(reader);
      //letters.removeAllElements();
      /* Until the end of the file has not been reached the word non the current line 
	 of the file is added to the letters vector */
      
      if (debug) 
	System.out.print ("<distribution> loadFile ");
      while ((line = formatedSource.readLine()) != null){ 
	/**indexOf,  subString, Trim
	   }*/
	str = new StringTokenizer (line);
	if (debug)
	  System.out.print("" + line + "; ");
	name = str.nextToken().charAt(0);
	value = new Integer (str.nextToken());
	myLetter = new Letter (name, value.intValue());
	letters.addElement(myLetter);
      }
      if (debug)
	System.out.println(" ");
    } 
    catch (FileNotFoundException e) {
      if (debug)
	System.out.println("<distribution> loadFile File not found");
    } 
    catch (IOException e) {
      if (debug)
	System.out.println("<distribution> loadFile Read Error");
    } 
    
    finally {
      try {
	
	sourceFlow.close();
      } catch(IOException e) {
	if (debug)
	  System.out.println("<distribution> loadFile Closing Error while reading");
      }
    }

  }
}
