/*
 * $Id: InitGamePanel.java,v 1.4 1998/04/07 08:55:54 vmallet Exp $
 *
 * 
 * $Log: InitGamePanel.java,v $
 * Revision 1.4  1998/04/07 08:55:54  vmallet
 * Added the dispose() method calls.
 *
 * Revision 1.3  1998/04/07 07:55:14  dunand
 * Ca marche reste a bien utiliser les dicos
 *
 * Revision 1.2  1998/04/07 06:33:00  dunand
 * With lots of nice graphics
 *
 * Revision 1.1  1998/04/06 10:12:52  dunand
 * Initial revision
 *
 *
 */
package scrobble;

import game.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.Panel;
import java.awt.Color;
import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.Font;
import java.util.*;

import com.sun.java.swing.event.*;
import com.sun.java.swing.border.*;
import com.sun.java.swing.*;

public class InitGamePanel extends JPanel implements GameLinkConstants, ScrobbleConstants{
  JFrame jframe;
  JPanel pane;
  GridLayout g;
  int numberOfPlayers;
  boolean debug = true, oneframe = true;
  JComboBox languageList,boardList;
  Configuration config;
  LinkFrame link;
  GameLinkFilter gameLink;


  public InitGamePanel(Configuration config,GameLinkFilter gameLink){

    //int i;


    this.config=config;
    this.gameLink=gameLink;
    link = new LinkFrame();

    jframe = new JFrame("Game Initializer Window");
    jframe.addWindowListener(new WindowAdapter() 
			     {
			       public void windowClosing(WindowEvent e) {  }
			     });
   
    pane = (JPanel) jframe.getContentPane();
    pane.setLayout(new BoxLayout(pane, BoxLayout.Y_AXIS));

    pane.setBorder(BorderFactory.createTitledBorder("Initializer"));

    /* Creates the Language Object */
    JPanel pane1 = new JPanel();
    pane1.setLayout(new BoxLayout(pane1, BoxLayout.X_AXIS));
    pane1.setBorder(BorderFactory.createTitledBorder("Languages"));
    pane.add(pane1);
    languageList = new JComboBox();
     
    /* tres laid ........
       for (i=0;i<4;i++) languageList.addItem(languageData[i]);*/
    Enumeration list = config.getLanguages();
    Language langue;
    for (; list.hasMoreElements(); ) 
      {
	langue = (Language) list.nextElement(); 
/* refaire */
	languageList.insertItemAt(langue.getName(),3-langue.getIdentifier());
      }
     
    languageList.setSelectedIndex(1);


    pane1.add(languageList);

    /* Creates the Board Shape Object */
    JPanel pane2 = new JPanel();
    pane2.setLayout(new BoxLayout(pane2, BoxLayout.X_AXIS));
    pane2.setBorder(BorderFactory.createTitledBorder("Board Shape"));
    pane.add(pane2);
    boardList = new JComboBox();
    /* tres laid ........
       for (i=0;i<4;i++) boardList.addItem(boardData[i]);*/
    boardList.addItem("default");
    boardList.setSelectedIndex(0);
    pane2.add(boardList);

    /* Register a listener for the ComboBox.*/
    ComboListener1 lListener = new ComboListener1();
    languageList.addActionListener(lListener);

    ComboListener2 cbListener = new ComboListener2();
    boardList.addActionListener(cbListener);

    /* The Radio Buttons */
    JRadioButton bouton1 = new JRadioButton("2");
    JRadioButton bouton2 = new JRadioButton("4",true);
    JRadioButton bouton3 = new JRadioButton("6");

    ButtonGroup group = new ButtonGroup();
    group.add(bouton1);
    group.add(bouton2);
    group.add(bouton3);

    /* Register a listener for the radio buttons.*/
    RadioListener myListener = new RadioListener();
    bouton1.addActionListener(myListener);
    bouton2.addActionListener(myListener);
    bouton3.addActionListener(myListener);

    JPanel pane3 = new JPanel();
    g = new GridLayout(0, 3);
    g.setHgap(3);
    g.setVgap(1);
    pane3.setLayout(g);
    pane3.setBorder(BorderFactory.createTitledBorder("Maximum Number Of Players"));
    pane3.add(bouton1);
    pane3.add(bouton2);
    pane3.add(bouton3);
    pane.add(pane3);

    /* The Buttons */
    ButtonListener bListener = new ButtonListener();
    JButton bouton4 = new JButton("Create");
    JButton bouton5 = new JButton("Cancel");
    //	bouton4.setKeyAccelerator('C');
    bouton4.addActionListener(bListener);
    //	bouton5.setKeyAccelerator('n');
    bouton5.addActionListener(bListener);


    JPanel pane4 = new JPanel();

    g = new GridLayout(0, 2);
    g.setHgap(3);
    g.setVgap(1);
    pane4.setLayout(g);
    pane4.setBorder(BorderFactory.createTitledBorder("Game"));
    pane4.add(bouton4);
    pane4.add(bouton5);
    pane.add(pane4);

    pane.validate();
    jframe.setSize(200, 250);

    jframe.setVisible(true);
    jframe.show();
  }

  /** An ActionListener that listens to the radio buttons. */
  class RadioListener implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      String Nbre = e.getActionCommand();
      Integer I;
      I = Integer.valueOf(Nbre,10);
      numberOfPlayers = I.intValue();	
      config.setMaxPlayer(numberOfPlayers);
      if (debug) System.out.println("<InitGamePanel> Changed NumberOfPlayers: " + numberOfPlayers);
    }
  }

  /** An ActionListener that listens to the buttons. */
  class ButtonListener implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      String Bout = e.getActionCommand();
      if (Bout=="Create") {
	// System.exit(1);
	link.setGroup(GAME_GROUP);
	link.setRequest(CONFIGURATION_CHOICE_MADE, NONE);
	link.setData(config);
	if (oneframe) {
	  gameLink.sendBlindly(link);
	  if (debug) System.out.println("<InitGamePanel> GameLink send");
	}
	
	jframe.dispose();
      }
      else if (Bout=="Cancel") {
	//System.out.println("");
	jframe.dispose();
      }
		

      if (debug) System.out.println("<InitGamePanel> Button Pressed: " + Bout);
    }
  }
  /** An ActionListener that listens to the CombBox. */
  class ComboListener1 implements ActionListener{
    public void actionPerformed(ActionEvent e) {
      String box = e.getActionCommand();
      String toto = (String) languageList.getSelectedItem();
      if (debug) System.out.println("Button Pressed: " + box + toto );
    }
  }

  /** An ActionListener that listens to the CombBox. */
  class ComboListener2 implements ActionListener{
    public void actionPerformed(ActionEvent e) {
      String toto = (String) boardList.getSelectedItem();
      String box = e.getActionCommand();
      if (debug) System.out.println("Button Pressed: " + box + toto );
    }
  }


  /*  public static void main(String args[]) {
      String[] data = {"un","dos","tres","..."};

      InitGamePanel toto = new InitGamePanel(data,data);

      }
  */
}

