/*
 * $Id: Language.java,v 1.3 1998/04/05 15:40:43 vmallet Exp $
 *
 * 
 * $Log: Language.java,v $
 * Revision 1.3  1998/04/05 15:40:43  vmallet
 * Now implements Serializable.
 *
 * Revision 1.2  1998/04/05 15:29:19  dunand
 * Changed a comment.
 *
 * Revision 1.1  1998/04/05 15:28:36  dunand
 * Initial revision
 *
 *
 */


package scrobble;

import java.io.*;


/**
 * Language.java
 *	
 * This class defines the <B>language</B> object. This object permits only to 
 * choose the language on the clients side.
 * 
 * @version $Revision: 1.3 $
 * @author  Loic Dunand (dunand@email.enst.fr)
 */

public class Language implements Serializable { 


  /**
   * Contains the name of the language the game is played in
   */
  String name;
  /**
   * Contains the identifier of the language choosen
   */
  int identifier;
  /**
	* Contains the description of this language in terms of Dictionnary and Distribution
	*/
  String description;

  // Constuctors


  /**
   * Creates a new language with the given identifier, name and description 
   * @param identifier the identifier of the language created
   * @param name the identifier of the language created
   * @param description the identifier of the language created

   */
  public Language(int identifier, String name, String description) {
    this.identifier = identifier;
	this.name = name;
	this.description = description;
	

  }

  
  // Methods


	/**
	* Returns the name of the language is played in.
	*/
  public String getName(){
	  return(name);
  }

	/**
	* Returns the identifier of the language is played in.
	*/
  public int getIdentifier(){
	  return(identifier);
  }

	/**
	* Returns a short description of the language is played in.
	*/
  public String getDescription(){
	  return(description);
  }
 	/**
	* Returns a String representation of Object.
	*/
  public String toString(){
	  return("\nidentifier : " + identifier + "\nname : " + name +  "\ndescription : "+ description );
  }
 
} 
