/*
 * $Id: Positioner.java,v 1.2 1998/04/06 09:46:15 vmallet Exp $
 *
 *
 * $Log: Positioner.java,v $
 * Revision 1.2  1998/04/06 09:46:15  vmallet
 * Now implements Serializable.
 *
 * Revision 1.1  1998/04/03 16:31:14  poivert
 * Initial revision
 *
 *
 */ 


package scrobble;

import java.io.*; 

/**
 * Positioner.java
 * 
 * positionne un objet sur le board
 * 
 * @version $Revision: 1.2 $
 * @author  Frederique Poivert (poivert@enst.fr)
 */
public class Positioner implements Serializable { 


  /**
   * Width position 
   */
  int widthPosition;

  /**
   * Height position 
   */
  int heightPosition;



  // Constructors


  /**
   * Creates a new Positioner
   */
  public Positioner() { 
  }  


  /**
   * Creates a new Positioner with the given coordinates
   * @param widthPosition the first coordinate of the new Positioner
   * @param heightPosition the second coordinate of the new Positioner
   */
  public Positioner(int widthPosition, int heightPosition) {   
    this.widthPosition = widthPosition;
    this.heightPosition = heightPosition;
  }


  
  // Methods


  /**
   * Modifies the first coordinate of the Positioner, that is widthPosition
   * @param newW the new first coordinate of the Positioner
   */
  public void setWidthPosition(int newW) {
    widthPosition = newW;
  }


  /**
   * Returns the first coordinate of the Positioner, that is widthPosition
   * @return widthPosition
   */
  public int getWidthPosition() {
    return widthPosition;
  }


  /**
   * Modifies the second coordinate of the Positioner, that is heightPosition
   * @param newH the new second coordinate of the Positioner
   */
  public void setHeightPosition(int newH) {
    heightPosition = newH;
  }


  /**
   * Returns the second coordinate of the Positioner, that is heightPosition
   * @return heightPosition
   */
  public int getHeightPosition() {
    return heightPosition;
  }


  /**
   * Compare the widthPosition and the heightPosition 
   * of the Positioner with these of another positioner.
   *
   * @return <code>true</code> if the widthPosition and the 
   *         heightPosition are the same ; <code>false</code> otherwise.
   */  

  public boolean comparePositions(Positioner p) {
    return ( (this.widthPosition == p.widthPosition) && 
	     (this.heightPosition == p.heightPosition) );
  }



}
 
