/*
 * $Id: ScrobbleConstants.java,v 1.3 1998/04/07 12:22:33 vmallet Exp $
 * 
 * $Log: ScrobbleConstants.java,v $
 * Revision 1.3  1998/04/07 12:22:33  vmallet
 * Added some board requests.
 *
 * Revision 1.2  1998/04/06 21:52:16  vmallet
 * Added a few constants, such as BAG and BOARD constants.
 *
 * Revision 1.1  1998/04/04 14:17:45  legras
 * Initial revision
 *
 */

package scrobble;

import game.*;

/**
 * ScrobbleConstants
 *
 * @author  Helene Legras (legras@enst.fr)
 * @version $Revision: 1.3 $
 */
public interface ScrobbleConstants {

 /** Server Status message : a bag has been created*/
  public static final int BAG_CREATED = 5000;

 /** Server Status message : a board has been created*/
  public static final int BOARD_CREATED = 5010;

 /** Server Status message : a player has been created*/
  public static final int PLAYER_CREATED = 5020;

 /** Server Status message : a player has moved*/
  public static final int PLAYER_LEFT = 5030;

 /** Server Status message : a letter has been taken in the bag*/
  public static final int LETTER_TAKEN = 5040;

 /** Server Status message : a word has not been accepted*/
  public static final int WORD_FALSE = 5050;

 /** Server Status message : the bag is empty*/
  public static final int BAG_EMPTY = 5060;

 /** Server Status message : the player is playing*/
  public static final int PLAYER_PLAYS = 5070;

 /** Server Status message : the object of configuration has to be writen*/
  public static final int CONFIGURATION = 5080;

  /** Server Status message : the object of configuration has been writen*/
  public static final int CONFIGURATION_CHOICE_MADE = 5090;

  public static final int ST_PLAY_WORD = 5100;

  /** Server Status message : the word isn't allowed because of its position */
  public static final int POSITION = 1;

  /** Server Status message : the word isn't allowed because it doesn't exist in the dictionary*/
  public static final int WORD = 2;


  /** Bag group : for communication between Bag objects */
  public static final int BAG_GROUP     = 200;

  /** Bag group : for communication between Bag objects */
  public static final int BOARD_GROUP     = 800;

  public static final int BOARD_PUT_WORD  = 8000;
  
  /**
   * The request which changes the letters of Bag.
   */
  public static final int RQ_BAGCHANGELETTERS = 2020; 
  
  /**
   * The request which changes the letters of Bag.
   */
  public static final int RQ_BAGCHANGEBAGSIZE = 2010; 
  



  /**
   * 
   */
  public static final int RQ_DECREASE_LETTER_COUNT = 2030;


}



















