/*
 * $Id: WordBuilder.java,v 1.3 1998/04/07 10:03:51 lozac Exp $
 *
 *
 * $Log: WordBuilder.java,v $
 * Revision 1.3  1998/04/07 10:03:51  lozac
 * added removeElementAt() and removeElement()
 *
 * Revision 1.2  1998/04/06 21:51:49  vmallet
 * Mainly fixed syntactic problems.
 *
 * Revision 1.1  1998/04/06 17:41:36  lozac
 * Initial revision
 *
 *
 */

package scrobble;

import game.*;
import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import com.sun.java.swing.*;
import com.sun.java.swing.border.*;

/**
 * WordBuilder.java
 * 
 * @version $Revision: 1.3 $
 * @author  Kristell Lozac (lozac@enst.fr)
 */
public class WordBuilder { 

  
  /**
   * The Word that is been built.
   */  
  Word word;


  // Constructor  

  /**
   * Creates a new WordBuilder
   */
  public WordBuilder() {
    word = new Word();
  } 

  // Methods

  /**
   * Puts a letter in the WordBuilder
   * @param newLetter the new letter contained by the WordBuilder.
   */  
  public void putLetter(Letter newLetter) {
    word.addLetter(newLetter);
  }

  /**
   * Puts a squarepositioner in the WordBuilder (It will be used when a player will click on a square)
   * @param newSquare the new squarepositioner contained by the WordBuilder.
   */  
  public void putSquarePositioner(SquarePositioner newSquare) {
    word.addSquarePositioner(newSquare);

  }
  
  /**
   * Return the built Word. 
   */  
  public Word getWord() {
    return word;
  }

  /**
   * Return a Panel that represents the word.
   */  
  public Component getComponent() {
    return word.getComponent();
  }

   /**
   * Remove a letter or a squarepositionner at the position index of the word that is been built.
   * @param index the index of the  letter or the squarepositionner to be removed.
   */  
  public void removeElementAt(int index) {
    word.removeElementAt(index);
  }

 /**
   * Remove a specified letter or a squarepositionner of the word that is been built.
   * @param object the object of the  letter or the squarepositionner to be removed.
   */  
  public void removeElement(Object object) {
    word.removeElement(object);
  }

} 
