/*
 * $Id: WordPositioner.java,v 1.1 1998/04/03 16:33:07 poivert Exp $
 *
 *
 * $Log: WordPositioner.java,v $
 * Revision 1.1  1998/04/03 16:33:07  poivert
 * Initial revision
 *
 *
 */ 

package scrobble;

/**
 * Wordpositioner.java
 *
 * herite de Positioner et positionne un mot
 * 
 *
 * @version $Revision: 1.1 $
 * @author  Frederique Poivert (poivert@enst.fr)
 */
public class WordPositioner extends Positioner { 


  public static final int HORIZONTAL = 1;
  public static final int VERTICAL   = 2;


  /**
   * Object of Positioner
   */
  Word word;


  /**
   * Direction of the Word
   */
  int direction;




  /**
   * Creates a new WordPositioner 
   
   */
  public WordPositioner() {   
    super();
  }


  /**
   * Creates a new WordPositioner with the given widthPosition, heightPosition, word and direction
   * @param widthPosition the widthPosition of the new WordPositioner being created
   * @param heightPosition the heightPosition of the new WordPositioner being created
   * @param word the word of the new WordPositioner being created
   * @param direction the direction of the new WordPositioner being created
   */
  public WordPositioner(int widthPosition, int heightPosition, Word word, int direction) {
    super(widthPosition, heightPosition);
    this.word      = word;
    this.direction = direction;
    
  }


  /**
   * Modifies the word of the WordPositioner
   * @param newWord the new word of the WordPositioner
   */
  public void setWord(Word newWord) {
    word = newWord;
  }


  /**
   * Returns the word of the WordPositioner
   * @return the word
   */
  public Word getWord() {
    return word;
  }


  /**
   * Modifies the direction of the WordPositioner
   * @param newDirection the new direction of the WordPositioner
   */
  public void setDirection(int newDirection) {
    direction = newDirection;
  }


  /**
   * Returns the direction of the WordPositioner
   * @return the direction
   */
  public int getDirection() {
    return direction;
  }


  

}

