/*
 * $Id: ServerBonusSquare.java,v 1.2 1998/04/05 20:09:51 lozac Exp $
 *
 *
 * $Log: ServerBonusSquare.java,v $
 * Revision 1.2  1998/04/05 20:09:51  lozac
 * Added the default constructor (hack for client GUI code).
 *
 * Revision 1.1  1998/04/04 14:34:00  lozac
 * Initial revision
 *
 *
 */ 

package scrobble.square;

import scrobble.*;
import java.util.*;

/** 
 * The <code>ServerBonusSquare</code> class is a server version of the  
 * <code>BonusSquare<code> class. It implements the methods of interface 
 * <code>CountingSquare</code> to calculate the word scoring. 
 * 
 * @version $Revision: 1.2 $
 * @author  Kristell Lozac (lozac@enst.fr)
 */
public class ServerBonusSquare extends BonusSquare implements CountingSquare{ 

  /**
   * Creates a new ServerBonusSquare
   */
  public ServerBonusSquare() { 
    iconName = "images/star.gif";
  }
  // Method
  /**
   * this methods is called when we calculate the score of a word. 
   * @param letter the letter on which the Square acts  
   * @return the value of letter on this square
   */
  public int letterAction(Letter letter) {
    return (letter.getValue());
  } 
  

  /**
   * This method is called when we calculate the score of the word.
   * @param word the word on which the Square acts
   * @return the value of word on this square
   */  
  public int wordAction(Word word){
    if (isEmpty() == true)
      return word.getScoring() + 10;
    else 
      return word.getScoring();
  }

  
  public static void main(String args[]) {
    Letter letter1 = new Letter('q',8);
    Vector vector = new Vector();
    Word word1 = new Word(vector,16);
    ServerBonusSquare x = new ServerBonusSquare();

    System.out.println("la lettre " + letter1.getName() + " vaut " + 
		       letter1.getValue());
    System.out.println("Avec la case " + x + " (+10) elle vaut " + 
		       x.letterAction(letter1));

    System.out.println("le mot initial vaut " + 
		       word1.getScoring());
    System.out.println("Avec la case " + x +" il vaut " + 
		       x.wordAction(word1));
      
    x.putLetter(letter1);
    System.out.println("Maintenat la case contient : " + x.getLetter().getName());
    System.out.println("Avec la case " + x +" le mot vaut " + 
		      x.wordAction(word1));
  
  }

}

