/*
 * $Id: ServerDoubleLetterSquare.java,v 1.2 1998/04/05 20:11:00 lozac Exp $
 *
 *
 * $Log: ServerDoubleLetterSquare.java,v $
 * Revision 1.2  1998/04/05 20:11:00  lozac
 * Added the default constructor (hack for client GUI code).
 *
 * Revision 1.1  1998/04/04 14:33:56  lozac
 * Initial revision
 *
 *
 */ 

package scrobble.square;

import scrobble.*;
import java.util.*;

/**
 * The <code>ServerDoubleLetterSquare</code> class is a server version of the  
 * <code>DoubleLetterSquare<code> class. It implements the methods of interface 
 * <code>CountingSquare</code> to calculate the word scoring. 
 *   
 * @version $Revision: 1.2 $
 * @author  Kristell Lozac (lozac@enst.fr)
 */
public class ServerDoubleLetterSquare extends DoubleLetterSquare implements CountingSquare {

  /**
   * Creates a new ServerDoubleLetterSquare
   */
  public ServerDoubleLetterSquare() { 
    iconName = "images/let2.gif";
  }
   
  // Method
  /**
   * This methods is called when we calculate the score of a word. 
   * @param letter the letter on which the Square acts  
   * @return the value of letter on this square
   */
  public int letterAction(Letter letter){
    if (isEmpty() == true)
      return 2 * letter.getValue();
    else
      return letter.getValue();
  } 
 
  /**
   * This method is called when we calculate the score of the word.
   * @param word the word on which the Square acts
   * @return the value of word on this square
   */  
  public int wordAction(Word word){
      return word.getScoring();
  }

  public static void main(String args[]) {
    Letter letter1 = new Letter('k',10);
    Vector vector = new Vector();
    Word word1 = new Word(vector,23);
    ServerDoubleLetterSquare x = new ServerDoubleLetterSquare();

    System.out.println("la lettre " + letter1.getName() + " vaut " + 
		       letter1.getValue());
    System.out.println("Avec la case " + x +" elle vaut " + 
		       x.letterAction(letter1));
    
    System.out.println("le mot initial vaut " + 
		       word1.getScoring());
    System.out.println("Avec la case " + x + " il vaut " + 
		       x.wordAction(word1));

    x.putLetter(letter1);
    System.out.println("Maintenant la case contient : " + x.getLetter().getName());
    System.out.println("la lettre " + letter1.getName() + " vaut " + 
		       letter1.getValue());
    System.out.println("Avec la case " + x + " elle vaut " + 
		       x.letterAction(letter1));
  }

}

