/*
 * $Id: ServerSquare.java,v 1.1 1998/04/04 14:33:44 lozac Exp $
 *
 *
 * $Log: ServerSquare.java,v $
 * Revision 1.1  1998/04/04 14:33:44  lozac
 * Initial revision
 *
 *
 */ 

package scrobble.square;

import scrobble.*;
import java.util.*;

/**
 * The <code>ServerSquare</code> class is a server version of the
 *<code>Square</code> class. It implements the methods of interface
 * <code>CountigSquare</code> class. It 
 * 
 * @version $Revision: 1.1 $
 * @author  Kristell Lozac (lozac@enst.fr)
 */
public class ServerSquare extends Square implements CountingSquare { 


 // Method
  /**
   * This methods is called when we calculate the score of a word. 
   * @param letter the letter on which the Square acts  
   * @return the value of letter on this square
   */
  public int letterAction(Letter letter){
      return letter.getValue();
  } 
 
  /**
   * This method is called when we calculate the score of the word.
   * @param word the word on which the Square acts
   * @return the value of word on this square
   */  
  public int wordAction(Word word){
      return word.getScoring();
  }


 public static void main(String args[]) {
    Letter letter1 = new Letter('k',10);
    Vector vector = new Vector();
    Word word1 = new Word(vector,23);
    ServerSquare x = new ServerSquare();

    System.out.println("la lettre " + letter1.getName() + " vaut " + 
		       letter1.getValue());
    System.out.println("Avec la case " + x +" elle vaut " + 
		       x.letterAction(letter1));
    
    System.out.println("le mot initial vaut " + 
		       word1.getScoring());
    System.out.println("Avec la case " + x + " il vaut " + 
		       x.wordAction(word1));
    System.out.println("Je remplis la case " + x + " avec " + letter1.getName());
    x.putLetter(letter1);
    System.out.println("La case devient : " + x);

 }
}
