/*
 * $Id: ServerTripleLetterSquare.java,v 1.2 1998/04/05 20:11:41 lozac Exp $
 *
 *
 * $Log: ServerTripleLetterSquare.java,v $
 * Revision 1.2  1998/04/05 20:11:41  lozac
 * Added the default constructor (hack for client GUI code).
 *
 * Revision 1.1  1998/04/04 14:32:21  lozac
 * Initial revision
 *
 *
 */ 

package scrobble.square;

import scrobble.*;
import java.util.*;

/**
 * The <code>ServerTripleLetterSquare</code> class is a server version of the  
 * <code>TripleLetterSquare<code> class. It implements the methods of interface 
 * <code>CountingSquare</code> to calculate the word scoring. 
 * 
 * @version $Revision: 1.2 $
 * @author  Kristell Lozac (lozac@enst.fr)
 */
public class ServerTripleLetterSquare extends TripleLetterSquare implements CountingSquare {

 /**
   * Creates a new ServerTripleLetterSquare
   */
  public ServerTripleLetterSquare() { 
    iconName = "images/let3.gif";
  }
  
  // Method
  /**
   * this methods is called when we calculate the score of a word. 
   * @param letter the letter on which the Square acts  
   * @return the value of letter on this square
   */
  public int letterAction(Letter letter){
    if (isEmpty() == true)
      return 3 * letter.getValue();
    else
      return letter.getValue();
  } 
 
  /**
   * This method is called when we calculate the score of the word.
   * @param word the word on which the Square acts
   * @return the value of word on this square
   */  
  public int wordAction(Word word){
      return word.getScoring();
  }

  public static void main(String args[]) {
    Letter letter1 = new Letter('k',10);
    Vector vector = new Vector();
    Word word1 = new Word(vector,23);
    ServerTripleLetterSquare x = new ServerTripleLetterSquare();

    System.out.println("la lettre " + letter1.getName() + " vaut " + 
		       letter1.getValue());
    System.out.println("Avec la case "+ x +" elle vaut " + 
		       x.letterAction(letter1));
    
    System.out.println("le mot initial vaut " + 
		       word1.getScoring());
    System.out.println("Avec la case " + x + " il vaut " + 
		       x.wordAction(word1));

    x.putLetter(letter1);
    System.out.println("Maintenat la case contient : " + x.getLetter().getName());
    System.out.println("la lettre " + letter1.getName() + " vaut " + 
		       letter1.getValue());
    System.out.println("Avec la case " + x +" occupee elle vaut " + 
		       x.letterAction(letter1));
  }
  
} 
